/* eslint-disable no-undef */

export const version = () => "1.0.0";

export class Sensor {
    constructor(id, name, data) {
        this._id;
        this.id = id;
        this._name;
        this.name = name;
        this._data;
        this.data = data;
    }
    get id() {
        return this._id || 0;
    }
    set id(val) {
        this._id = val;
    }
    set name(val) {
        this._name = val;
    }
    get name() {
        return this._name || 0;
    }
    set data(val) {
        this._data = val;
    }
    get data() {
        return this._data;
    }

    toString() {
        return (`id : (${this.id},  le nom : ${this.name},  les données : ${this.data})`);
  }
}


export class Data {

}


export class TimeSeries extends Data{
    constructor(labels,values){
        super();
        this._values = values;
        this._labels = labels;
    }
    get values() {
        return this._values ;
    }
    set values(val) {
        this._values = val;
    }
    set labels(val) {
        this._labels = val;
    }
    get labels() {
        return this._labels;
    }
    toString() {
        return (`(${this.values}, ${this.labels})`);
  }
}

export class Datum extends Data{
    constructor(value){
        super();
        this._value = value;
    }
    get value() {
        return this._value ;
    }
    set value(val) {
        this._value = val;
    }
    toString() {
        return (`la valeur est : (${this.value})`);
  }

}

export class Temperature extends Sensor{
    constructor(id, name, data, total,incr,moyenne) {
        super(id, name, data);
        this._total;
        this.total = total;
        this._incr;
        this.incr = incr;
        this._moyenne;
        this.moyenne = moyenne;
    }
    get total() {
        return this._total ;
    }
    set total(val) {
        this._total = val;
    }

    get incr() {
        return this._incr ;
    }
    set incr(val) {
        this._incr = val;
    }

    get moyenne() {
        return this._moyenne ;
    }
    set moyenne(val) {
        this._moyenne = val;
    }
    toString() {
        return (`les données du capteur de Temperature sont : id : ${this.id}, nom : ${this.name} , data : ${this.data}, la moyenne est de : ${this.moyenne}, pour ${this.iteration} iterations \n`);
  }
}

export class Humidity extends Sensor{
    constructor(id, name, data) {
        super(id, name, data);
    }
    toString() {
        return (`les données du capteur de humidité sont : id : ${this.id}, nom : ${this.name}, data : ${this.data}\n`);
  }
}

export class Light extends Sensor{
    constructor(id, name, data) {
        super(id, name, data);
    }
    toString() {
        return (`les données du capteur de lumière sont : id : ${this.id}, nom : ${this.name}, data : ${this.data}\n`);
  }
}

export class Door extends Sensor {
    constructor(id, name, data) {
        super(id, name, data);
    }
    toString() {
        return (`les données du capteur de la porte sont : id : ${this.id}, nom : ${this.name}, data : ${this.data}\n`);
  }
}

export class Speed extends Sensor{
    constructor(id, name, data) {
        super(id, name, data);
    }
    toString() {
        return (`les données du capteur de vitesse sont : id : ${this.id}, nom : ${this.name}, data : ${this.data}\n`);
  }
}

export class Switch extends Sensor{
    constructor(id, name, data) {
        super(id, name, data);
    }
    toString() {
        return (`les données du switch sont : id : ${this.id}, nom : ${this.name} , data : ${this.data}\n`);
  }
}

//rajout pour le tp web socket
export class Percent extends Sensor{
    constructor(id, name, data, total, incr, moyenne) {
        super(id, name, data);
        this._total;
        this.total = total;
        this._incr;
        this.incr = incr;
        this._moyenne;
        this.moyenne = moyenne;
    }
    get total() {
        return this._total ;
    }
    set total(val) {
        this._total = val;
    }

    get incr() {
        return this._incr ;
    }
    set incr(val) {
        this._incr = val;
    }

    get moyenne() {
        return this._moyenne ;
    }
    set moyenne(val) {
        this._moyenne = val;
    }
    toString() {
        return (`les données du capteur percent sont : id : ${this.id}, nom : ${this.name} , data : ${this.data}\n `);
    }
}

export function createSensor (sens, type) {

    if (type === "TEMPERATURE")
        return new Temperature(sens.id, sens.name, sens.data, 1,sens.data);
    else if (type === "HUMIDITY") {
        return new Humidity(sens.id, sens.name, sens.data);
    } else if (type === "LIGHT") {
        return new Light(sens.id, sens.name, sens.data);
    } else if (type === "SWITCH" || type === "ON_OFF") {
        return new Switch(sens.id, sens.name, sens.data);
    } else if (type === "DOOR") {
        return new Door(sens.id, sens.name, sens.data);
    } else if (type === "PERCENT") {
        return new Percent(sens.id, sens.name, sens.data,1,sens.data);  //rajout tp web socket
    } else {
        return new Speed(sens.id, sens.name, sens.data);
    }
}


